/*
    WOHTTPProtocol.h
    (c) Copyright 1996 NeXT Software Inc.
    All Rights Reserved.
*/
#ifndef WOHTTPPROTOCOL
#define WOHTTPPROTOCOL
#include <stdio.h>
#include "WODict.h"		/* Dictionary container. See dict.h for API */

#ifndef NET_H			/* Never defined except in NSAPI */
#ifdef WIN32
#include <winsock.h>
#else /* XP_UNIX */
#include <sys/socket.h>
#endif /* WIN32 */
#ifdef WIN32
#define net_close(sd) closesocket(sd)
#ifndef SYS_NETFD_T		/* This is some NSAPI3.0 crap */
typedef SOCKET SYS_NETFD;
#endif
#else /* XP_UNIX */
#define net_close(sd) close(sd)
#ifndef SYS_NETFD_T		/* This is some NSAPI3.0 crap */
typedef int SYS_NETFD;
#endif
#endif /* WIN32 */
#endif /* NET_H */

typedef struct _httpRequest {
    char *requestLine;
    dict *headers;
    void *content;
    int isNSAPI;
    int isISAPI;
    SYS_NETFD clientsd;
} WOHTTPRequest;			/* the request object */

typedef struct _httpResponse {
    char *statusLine;
    dict *headers;
    void *content;
} WOHTTPResponse;			/* the response object */

int WOHTTPRequestSend(FILE *fp, WOHTTPRequest *aRequest);
WOHTTPResponse * WOHTTPResponseReceive(FILE *fp);
void WO_request_free(WOHTTPRequest *aRequest);
void WO_response_free(WOHTTPResponse *aResponse);
#endif

