#include <stdlib.h>
#ifndef WIN32
#include <unistd.h>
#else
#include <windows.h>
#include <winsock.h>
#endif
#include <sys/stat.h>
#include <errno.h>
#include <string.h>

#ifdef NeXT
#include <libc.h>
#endif

#include "WOTmpConfig.h"

/* returns -1 if any error occured. 
 * on success returns 0.
 */
int WORecordPortInTMPConfig(FILE *fp, const char *appName, int port, int pid) {
    int r;
    struct app_table record;
    rewind(fp);
    do {
	r = fread(&record,sizeof(struct app_table),1,fp);

/* Exit this loop on EOF */
	if (!r) break;

/* Log any read failure, this is important ! */
	if (r < 0) {
	    logWebObjects(LOGCGI_WARNING," -- WOTmpConfig : Error \"%s\" occured while reading %s info from temporary configuration file",strerror(errno),appName);
	    return -1;
	}
	if ((!strcmp(appName,record.appName))) {

/* Rewind of a structure length */
	    if (fseek(fp,sizeof(struct app_table) * (-1), SEEK_CUR) < 0) {
		logWebObjects(LOGCGI_WARNING," -- WOTmpConfig : Error \"%s\" occured while rewinding in temporary configuration file",strerror(errno));
		return -1;
	    }
	    record.port = port;
	    record.pid = pid;

/* Write the new structure on the old one */
	    if (!fwrite(&record,sizeof(struct app_table),1,fp)) {
		logWebObjects(LOGCGI_WARNING," -- WOTmpConfig : Error \"%s\" occured while writing %s port %d to config file",strerror(errno),appName,port);
	    return -1;
	    }
	    return 0;
	}
    }
    while(r);

/* Append the new structure at the end of the file */
    if (port != -1) {
        strncpy(record.appName,appName, WO_MAX_PATH - 1);
        record.appName[WO_MAX_PATH - 1] = '\0';
	record.port = port;
	record.pid = pid;
	if (!fwrite(&record,sizeof(struct app_table),1,fp)) {
	    logWebObjects(LOGCGI_WARNING," -- WOTmpConfig : Error \"%s\" occured while writing %s port %d to config file",strerror(errno),appName,port);
	    return -1;
	}
	return 0;
    }
    return -1;
}

